﻿// WOPR - Switch 
// Windows phone 8.1 (C) 2016 Hackertje
using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Net.Http;
using System.Runtime.InteropServices.WindowsRuntime;
using Windows.Foundation;
using Windows.Foundation.Collections;
using Windows.UI.Xaml;
using Windows.UI.Xaml.Controls;
using Windows.UI.Xaml.Controls.Primitives;
using Windows.UI.Xaml.Data;
using Windows.UI.Xaml.Input;
using Windows.UI.Xaml.Media;
using Windows.UI.Xaml.Navigation;


namespace WOPR_Switch {

 public sealed partial class MainPage : Page {
  public MainPage() {
   this.InitializeComponent();

   this.NavigationCacheMode = NavigationCacheMode.Required;
  }


  protected override void OnNavigatedTo(NavigationEventArgs e) {
   ShowStatus();
  }

  async void ShowStatus() {
   try {
    HttpClient wc = new HttpClient();
    string sStatus = await wc.GetStringAsync("http://yourname.mynetgear.com:8080/?t=" + (DateTime.Now.Ticks + 1).ToString());
    if(sStatus.EndsWith("ON")) Status.Text = "On"; else Status.Text = "Off";
   }
   catch(Exception) { }
  }

  private async void btnOff_Click(object sender, RoutedEventArgs e) {
   try {
    HttpClient wc = new HttpClient();
    string sStatus = await wc.GetStringAsync("http://yourname.mynetgear.com:8080/?t=" + DateTime.Now.Ticks);
    int key = Convert.ToInt32(sStatus.Substring(0, sStatus.IndexOf("-")));
    int hashresult = (key - 768) * 3; // Should be the same as in the Arduino-sketch!
    sStatus = await wc.GetStringAsync("http://yourname.mynetgear.com:8080/off?a=" + hashresult);
    ShowStatus();
   }
   catch(Exception) {
   }
  }

  private async void btnOn_Click(object sender, RoutedEventArgs e) {
   try {
    HttpClient wc = new HttpClient();
    string sStatus = await wc.GetStringAsync("http://yourname.mynetgear.com:8080/?t=" + DateTime.Now.Ticks);
    int key = Convert.ToInt32(sStatus.Substring(0, sStatus.IndexOf("-")));
    int hashresult = (key - 768) * 7;
    sStatus = await wc.GetStringAsync("http://yourname.mynetgear.com:8080/on?a=" + hashresult);
    ShowStatus();
   }
   catch(Exception) {
   }
  }
 }

}
